/*
 *  com.electronicmuse - DESCRIPTION OF PACKAGE
 *  Copyright (C) 2003 RossLodge
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  The author of this program grants you the ability to use this code
 *  in conjunction with code that is covered under the Open Gaming License
 *
 *  DefaultRandom.java
 *
 *  Created on Oct 19, 2003, 1:20:21 PM
 */
package com.electronicmuse.djep;

import java.util.Date;
import java.util.Random;

import edu.cornell.lassp.houle.RngPack.RandomSeedable;

/**
 * @author RossLodge
 * 
 * <p></p>
 */
public class DefaultRandom extends RandomSeedable
{
	Random m_random;
	
	public DefaultRandom()
	{
		m_random = new Random();
	}
	
	public DefaultRandom(Date d)
	{
		m_random = new Random(ClockSeed(d));
	}

	/**
	 * <p></p>
	 * 
	 * @see edu.cornell.lassp.houle.RngPack.RandomElement#raw()
	 */
	public double raw()
	{
		return m_random.nextDouble();
	}

}
